(define combination
  (lambda (k set)
    (cond ((null? set) '())
	  ((= k 0) '(()))
	  ((= k 1) (map list set))
	  (else (append (map (lambda (x)
			       (cons (car set) x))
			     (combination (- k 1) (cdr set)))
			(combination k (cdr set)))))))


(define (seq from to)
    (if (= from to) (list to) (cons from (seq (+ from 1) to))))

(combination 10 (seq 1 20))
