;; with repetition

(define (append! x y)
  (if (null? x) y
    (let loop ((z x))
      (if (null? (cdr z))
	(begin
	  (set-cdr! z y)
	  x)
	(loop (cdr z))))))
(define (mapx f list)
    (if (null? list) list
          (cons (f (car list)) (mapx f (cdr list)))))

(define combination-dup
  (lambda (k set)
    (if (null? set) '()
	  (if (= k 0) '(())
	    (append! (mapx (lambda (x)
			   (cons (car set) x))
			 (combination-dup (- k 1) set))
		    (combination-dup k (cdr set)))))))



(define (seq from to)
    (if (= from to) (list to) (cons from (seq (+ from 1) to))))

(combination-dup 5 (seq 1 25))
