;;; DIVREC -- Benchmark which divides by 2 using lists of n ()'s.
 
;(define (create-n n)
;  (do ((n n (- n 1))
;       (a '() (cons '() a)))
;      ((= n 0) a)))

(define (create-n n)
  (let loop 
    ((n n)
     (a '()))
    (if (= n 0) a
      (loop (- n 1) (cons '() a)))))

 
(define *ll* (create-n 200))

(define (recursive-div2 l)
  (cond ((null? l) '())
        (else (cons (car l) (recursive-div2 (cddr l))))))
  
(define (loop n)
  (recursive-div2 *ll*)
  (if (> n 0) (loop (- n 1))))
(loop 10000)

