(define power-set
  (lambda (set)
    (if (null? set)
      '(())
      (append (map (lambda (x)
		     (cons (car set) x))
		   (power-set (cdr set)))
	      (power-set (cdr set))))))

(define (seq from to)
    (if (= from to) (list to) (cons from (seq (+ from 1) to))))
(power-set (seq 1 18))
