;(define (bubblesort l)
;  (define (swap-pass l)
;    (if (equal? (length l) 1)
;      l
;      (let ((fst (car l)) (snd (cadr l)) (rest (cddr l)))
;	(if (> fst snd)
;	  (cons snd (swap-pass (cons fst rest)))
;	  (cons fst (swap-pass (cons snd rest)))))))
;  (define (iter times val)
;    (if (> times 1)
;      (iter (- times 1)(swap-pass val))
;      (swap-pass val)))
;  (iter (length l) l))


;; http://en.wikibooks.org/wiki/Algorithm_implementation/Sorting/Bubble_sort#Scheme
(define (bubblesort l)
  (define (swap-pass l)
    (if (equal? (length l) 1) 
      l
      (let ((fst (car l))(snd (cadr l))(rest (cddr l)))
	(if (> fst snd) 
	  (cons snd (swap-pass (cons fst rest)))
	  (cons fst (swap-pass (cons snd rest)))))))
  (let for ((times (length l))
	    (val l))
    (if (> times 1)
      (for (- times 1)(swap-pass val))
      (swap-pass val))))


(define (random-list len)
  (define (generate len p q s result)
    (if (= len 0) result
      (let ((value (modulo (* s s) (* p q))))
	(generate (- len 1) p q value (cons value result)))))
  (generate len 101 17 3 '()))



(bubblesort (random-list 1000))
