
(define (matrix-create n value)
  (define (iter m v)
    (if (= m 0) '() (cons v (iter (- m 1) v))))
  (iter n (iter n value)))

(define (multiply m n)
  (define size (length m))
  (define (get-element row cell)
    (define (iter i result)
      (if (= i size) result
      	(iter (+ i 1) (+ result (* (matrix-get m row i) (matrix-get n i cell))))))
    (iter 0 0)) 
  (define (iter-cell row cell)
    (if (= cell size) '()
      (cons (get-element row cell) (iter-cell row (+ cell 1)))))
  (define (iter-row row)
    (if (= row size) '()
      (cons (iter-cell row 0) (iter-row (+ row 1)))))
  (iter-row 0))


(define SIZE2 50)
(define C (matrix-create SIZE2 1))
(define D (matrix-create SIZE2 1))
(multiply C D)
