(define permutation
  (lambda (l)
    (if (null? l)
      '(())
      (let perm
	((base l)
	 (p-set (cdr l)))
	(if (null? base)
	  '()
	  (append
	    (map (lambda (x)
		   (cons (car base) x))
		 (permutation p-set))
	    (perm (cdr base)
		  (cdr (append p-set (list (car base)))))))))))

(define (seq from to)
    (if (= from to) (list to) (cons from (seq (+ from 1) to))))

(permutation (seq 1 9))
