;; without repetition

;(define (mapx f list)
;  (if (null? list) list
;    (cons (f (car list)) (mapx f (cdr list)))))

(define (append-x x y)
  (if (null? x) y
    (let loop ((z x))
      (if (null? (cdr z))
	(begin
	  (set-cdr! z y)
	  x)
	(loop (cdr z))))))


(define combination
  (lambda (k set)
    (if (null? set) '()
      (if (= k 0) '(())
	(if (= k 1) (map list set)
	 (append! (map (lambda (x)
			       (cons (car set) x))
			     (combination (- k 1) (cdr set)))
			(combination k (cdr set))))))))


(define (seq from to)
    (if (= from to) (list to) (cons from (seq (+ from 1) to))))

;(map (lambda (x) (display x) (newline)) 
     (combination 10 (seq 1 20));)
