;;; DIVITER -- Benchmark which divides by 2 using lists of n ()'s.
 
(define (create-n n)
  ;(do ((n n (- n 1))
  ;     (a '() (cons '() a)))
  ;    ((= n 0) a)))

  (let loop
    ((n n)
     (a '()))
    (if (= n 0) a
      (loop (- n 1) (cons '() a)))))

 
(define *ll* (create-n 200))

(define (iterative-div2 l)
;  (do ((l l (cddr l))
;       (a '() (cons (car l) a)))
;      ((null? l) a)))
  (let loop ((l l)
	     (a '()))
    (if (null? l) a
      (loop (cddr l) (cons (car l) a)))))

(iterative-div2 *ll*)

(define (loop n)
  (iterative-div2 *ll*)
  (if (> n 0) (loop (- n 1))))
(loop 100000)
