;;
;; The Towers Of Hanoi
;; Scheme
;; Copyright (C) 1998 Amit Singh. All Rights Reserved.
;; http://hanoi.kernelthread.com
;;

(define (dohanoi n to from using)
  (if (> n 0)
    (begin
      (dohanoi (- n 1) using from to)
      (display 'move)
      (display from)
      (display '-->)
      (display to)
      (newline)
      (dohanoi (- n 1) to using from)
      #t)
    #f))

(define (hanoi n)
  (dohanoi n 3 1 2))

(hanoi 19)
