
(define (random-generator seed)
  (let ((last seed))
    (lambda ()
      (set! last (abs (modulo (+ (* last 16807) 0) 10000000)))
      (/ last 10000000))))



(define (monte-carlo attempts)
(define (experiment)
  (let ((x (random))
	(y (random)))
    (<= (sqrt (+ (* x x) (* y y))) 1)))

  (define random (random-generator 3))
  (let loop ((count attempts)
	     (successful 0))
    (cond ((zero? count) (* 4.0 (/ successful attempts)))
	  ((experiment) (loop (- count 1) (+ successful 1)))
	  (else (loop (- count 1) successful)))))

(let ((attempts 10000))
(display 
 (/
   (+
   (monte-carlo attempts)
   (monte-carlo attempts)
   (monte-carlo attempts)
   (monte-carlo attempts)
   (monte-carlo attempts)
   (monte-carlo attempts)
   (monte-carlo attempts)
   (monte-carlo attempts)
   (monte-carlo attempts)
   (monte-carlo attempts)
   (monte-carlo attempts)
   (monte-carlo attempts)
   (monte-carlo attempts)
   (monte-carlo attempts)
   (monte-carlo attempts)
   (monte-carlo attempts)
   (monte-carlo attempts)
   (monte-carlo attempts)
   (monte-carlo attempts)
   (monte-carlo attempts)

   )
   20)))

(newline)
